<?php
namespace Fiscal\Logic\NotaFiscal\Lancamento;

/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 14/01/13
 * Time: 14:47
 * To change this template use File | Settings | File Templates.
 */
use Fiscal\Entities\Notafiscal;
use Fiscal\Logic\NotaFiscal\ProceduresNF;
use Fiscal\Logic\NotaFiscal\Saida\NFSaida;
use Setforms2\Shared\Registry;

class LancamentoNFSaida
{

    private static $instance;

    private function __construct()
    {
        $this->connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
    }

    public static function getInstance()
    {
        if (!isset(self::$instance)) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    public static function atualizaStatusNF(Notafiscal $notafiscal, $status)
    {
        $notafiscal->setIdstatus($status);
        $notafiscal->persist();
        Registry::getEntityManager()->flush();
    }

    public function executa(NFSaida $NFSaida)
    {
        try {
            $this->connection->beginTransaction();

            $NFSaida->beforeLancamento();
            $this->fecharNotaFiscal($NFSaida);
            $NFSaida->afterLancamento();

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollBack();
            throw $e;
        }
    }

    private function fecharNotaFiscal(NFSaida &$NFSaida)
    {
        try {
            /* @var $notafiscal \Fiscal\Entities\Notafiscal */
            $notafiscal = $NFSaida->getNotaFiscal();
            /* @var $tipoOperac \Geral\Entities\Tipooperac */
            $tipoOperac = \Geral\Entities\Tipooperac::findOneByCdtipooperAndIdentrsaidopAndNrorg($notafiscal->getCdtipooper(), 'S', \Geral\Util\Ambiente::getNrorg());

            if ($tipoOperac->getIdatuesttpop() == 'S') {
                /* @var $lancamentoEstoque \Estoque\Entities\Lanctoestoq */
                $lancamentoEstoque = \Estoque\Entities\Lanctoestoq::findOneByCdfilialAndNrlanctonfAndNrorg(
                    $notafiscal->getCdfilial(),
                    $notafiscal->getNrlanctonf(), $notafiscal->getNrorg()
                );

                if ($lancamentoEstoque instanceof \Estoque\Entities\Lanctoestoq) {
                    $lancestq = $lancamentoEstoque->getNrlancestq();
                } else {
                    $lancestq = \Geral\Util\NovoCodigo::geraCodigo(
                        \Geral\Util\Ambiente::getNrorg(),
                        \Estoque\Entities\Lanctoestoq::CDCONTADOR_LANCTOESTOQ . \Geral\Util\Ambiente::getCdFilial()
                    );
                }
            } else {
                $lancestq = '';
            }

            $return = ProceduresNF::callProcedureImpostoSaida($notafiscal, $lancestq);
            if (!empty($return) && isset($return["P_VRNOTAFISC"])) {
                $NFSaida->setTotalNF(\Geral\Util\Util::decimalToFloat($return["P_VRNOTAFISC"]));
            }

        } catch (\Exception $e) {
            throw $e;
        }
    }
}
