function AlteracaoAprovacaoAfController(ScreenService, maskEngine, ZhUtil, General, Parametros, AlteracaoAprovacaoAfService, ZHPromise, MessageService) {

    var self = this;
    var maskProd = '';
    var acrescimo = 0;

    this.defineParametros = function(){
        maskProd = {
            "type": "fix",
            "params": {
                "mask": getLocalVar('CDPICTPROD')
            }
        };
        
        return Parametros.parcmpsup(getLocalVar('CDFILIAL')).then(function(callback){
            if (callback.dataset.parcmpsup.length) {
                acrescimo = callback.dataset.parcmpsup[0].VRACRESCIMOAF ? _toFloat(callback.dataset.parcmpsup[0].VRACRESCIMOAF) : null;
            }
        });

    };

    this.defaultFiltro = function(widgetFiltro) {
        if (!widgetFiltro.currentRow.TIPOAF) {
            widgetFiltro.newRow();
        }
        widgetFiltro.getField('TFORNECEDOR').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TFORNECEDOR'),widgetFiltro.getField('FORNECEDOR'));
        widgetFiltro.getField('TNMCOMPRADOR').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TNMCOMPRADOR'),widgetFiltro.getField('NMCOMPRADOR'));
        widgetFiltro.getField('TNMFILIALLANC').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TNMFILIALLANC'),widgetFiltro.getField('NMFILIALLANC'));
        widgetFiltro.getField('TNMFILIALDEST').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TNMFILIALDEST'),widgetFiltro.getField('NMFILIALDEST'));
        widgetFiltro.getField('TAUTOFORNE').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TAUTOFORNE'),widgetFiltro.getField('AUTOFORNE'));
    };

    this.filtraAF = function(widgetAF, widgetFiltro){
        var rowFiltro = widgetFiltro.currentRow;
        if(widgetFiltro.isValid() && this.validaFiltro(rowFiltro)) {
            var dataSourceFilter = [];
            dataSourceFilter = [
                {
                    "name": "FORNECEDOR",
                    "value": this.montaLista(rowFiltro.TFORNECEDOR, rowFiltro.FORNECEDOR),
                    "operator": "="
                },
                {
                    "name": "COMPRADOR",
                    "value": this.montaLista(rowFiltro.TNMCOMPRADOR, rowFiltro.NMCOMPRADOR),
                    "operator": "="
                },
                {
                    "name": "CDFILLANC",
                    "value": this.montaLista(rowFiltro.TNMFILIALLANC, rowFiltro.NMFILIALLANC),
                    "operator": "="
                },
                {
                    "name": "CDFILDEST",
                    "value": this.montaLista(rowFiltro.TNMFILIALDEST, rowFiltro.NMFILIALDEST),
                    "operator": "="
                },
                {
                    "name": "IDSITUACAO",
                    "value": this.montaTipoAf(rowFiltro.TIPOAF),
                    "operator": "="
                },
                {
                    "name": "DTAFINI",
                    "value": rowFiltro.DTAFINI,
                    "operator": "="
                },
                {
                    "name": "DTAFFIN",
                    "value": rowFiltro.DTAFFIN,
                    "operator": "="
                },
                {
                    "name": "DTENTINI",
                    "value": rowFiltro.DTENTREGAINI,
                    "operator": "="
                },
                {
                    "name": "DTENTFIN",
                    "value": rowFiltro.DTENTREGAFIN,
                    "operator": "="
                },
                {
                    "name": "PRODINI",
                    "value": rowFiltro.CDPRODINICIAL ? rowFiltro.CDPRODINICIAL : '',
                    "operator": "="
                },
                {
                    "name": "PRODFIN",
                    "value": rowFiltro.CDPRODFINAL.padEnd(20,'Z'),
                    "operator": "="
                },
                {
                    "name": "AUTOFORNE",
                    "value": this.montaLista(rowFiltro.TAUTOFORNE, rowFiltro.AUTOFORNE),
                    "operator": "="
                },
                {
                    "name": "NRORG",
                    "value": getLocalVar('NRORG'),
                    "operator": "="
                }
            ];

            widgetAF.dataSourceFilter = dataSourceFilter;
            widgetAF.reload().then(function(){
                self.defineParametros().then(function(){
                    ScreenService.closePopup();
                    widgetAF.activate();
                });
            });
        }
    };

    this.retiraHoraData = function(widgetAF) {
        var dataSourceWidget = widgetAF.dataSource.data;

        for (var posicao in dataSourceWidget) {
            dataSourceWidget[posicao].DTAUTOFORN = dataSourceWidget[posicao].DTAUTOFORN ? dataSourceWidget[posicao].DTAUTOFORN.split(" ")[0] : dataSourceWidget[posicao].DTAUTOFORN;
            dataSourceWidget[posicao].DTPROGENTAF = dataSourceWidget[posicao].DTPROGENTAF ? dataSourceWidget[posicao].DTPROGENTAF.split(" ")[0] : dataSourceWidget[posicao].DTPROGENTAF;
        }
    };

    this.montaStripe = function(widgetStripe, rowFiltro){
        var produto = widgetStripe.getField('NMPRODUTO');
        var dataAf = widgetStripe.getField('DTAF');
        var dataEntrega = widgetStripe.getField('DTENTREGA');

        if(rowFiltro.NMPRODINICIAL){
            var inicial = Util.applyMask(rowFiltro.CDPRODINICIAL, maskProd, maskEngine, ZhUtil);
            var final = Util.applyMask(rowFiltro.CDPRODFINAL, maskProd, maskEngine, ZhUtil);

            produto.label = ScreenService.i18n('Produto: ')+inicial+' a '+final;
            produto.isVisible = true;
        } else{
            produto.isVisible = false;
        }

        if(rowFiltro.DTENTREGAINI){
            dataEntrega.label = ScreenService.i18n('Período Entrega: ')+rowFiltro.DTENTREGAINI+' a '+rowFiltro.DTENTREGAFIN;
            dataEntrega.isVisible = true;
        } else{
            dataEntrega.isVisible = false;
        }

        if(rowFiltro.DTAFINI){
            dataAf.label = ScreenService.i18n('Período AF: ')+rowFiltro.DTAFINI+' a '+rowFiltro.DTAFFIN;
            dataAf.isVisible = true;
        } else{
            dataAf.isVisible = false;
        }
    };

    this.montaLista = function(fieldTodos, fieldSelect){
        if(fieldTodos == 'T'){
            return 'T';
        } else{
            return fieldSelect.join();
        }
    };

    this.montaTipoAf = function(selectTipoAf){
        var tipoAf = '';
        tipoAf += selectTipoAf.join('_');
        return tipoAf;
    };

    this.validaFiltro = function(currentRow){
        var tipoAf = verificaTipoAf(currentRow.TPAFAUTOMATICA, currentRow.TPAFMANUAL);
        var dataAf = verificaData(currentRow.DTAFINI, currentRow.DTAFFIN, 'da AF');
        var dataEntrega = verificaData(currentRow.DTENTREGAINI, currentRow.DTENTREGAFIN, 'de entrega');
        var produto = verificaProduto(currentRow.CDPRODINICIAL, currentRow.CDPRODFINAL);

        if(!tipoAf || !dataAf || !dataEntrega || !produto){
            return false;
        } else{
            return true;
        }
    };

    function verificaTipoAf(automatica, manual){
        if(automatica == 'N' && manual == 'N'){
            MessageService.showMessageByCode("TIPO_AF_REQUIRED");
            return false;
        } else{
            return true;
        }
    }

    function verificaData(inicial, _final, mensagem) {

        if(inicial || _final) {
            if(!inicial) {
                MessageService.showMessageByCode("DTA_INICIAL_REQUIRED");
                return false;
            }
            if(!_final) {
                MessageService.showMessageByCode("DTA_FINAL_REQUIRED");
                return false;
            }
            if(moment(inicial, 'DD/MM/YYYY') > moment(_final, 'DD/MM/YYYY')) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                return false;
            }
        }

        return true;
    }

    function verificaProduto(inicial, _final) {
        if(inicial || _final) {
            if(!inicial) {
                MessageService.showMessageByCode("PROD_INICIAL_REQUIRED");
                return false;
            }
            if(!_final) {
                MessageService.showMessageByCode("PROD_FINAL_REQUIRED");
                return false;
            }
			if(!General.comparaPratoProduto(inicial, _final, getLocalVar('CDPICTPROD'))) {
			    MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
				return false;
			}
        }

        return true;
    }

    this.filtraUnidadeAgrupamento = function(fieldUnidades, stringUnidades){
        if(stringUnidades) {
            var unidades = stringUnidades.split('_');
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "CDFILIAL",
                    "value": "",
                    "operator": "IN"
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades});
        } else{
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
        }
    };

    this.filtraAfUnidade = function(fieldAf, unidadesLanc, unidadesDest){
        if(unidadesLanc.length && unidadesDest.length) {
            fieldAf.dataSourceFilter = [
                {
                    "name": "CDFILDEST",
                    "value": "",
                    "operator": "IN"
                },
                {
                    "name": "CDFILLANC",
                    "value": "",
                    "operator": "IN"
                },
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
            this.defineSelectWidget(fieldAf);
            General.onClickDependentField(fieldAf, {'CDFILDEST': unidadesDest, 'CDFILLANC': unidadesLanc, 'NRORG': getLocalVar('NRORG')});
        } else{
            if(unidadesLanc.length){
                fieldAf.dataSourceFilter = [
                    {
                        "name": "CDFILLANC",
                        "value": "",
                        "operator": "IN"
                    },
                    {
                        "name": "NRORG",
                        "value": "",
                        "operator": "="
                    }
                ];
                this.defineSelectWidget(fieldAf);
                General.onClickDependentField(fieldAf, {'CDFILLANC': unidadesLanc, 'NRORG': getLocalVar('NRORG')});
            } else{
                if(unidadesDest.length){
                    fieldAf.dataSourceFilter = [
                        {
                            "name": "CDFILDEST",
                            "value": "",
                            "operator": "IN"
                        },
                        {
                            "name": "NRORG",
                            "value": "",
                            "operator": "="
                        }
                    ];
                    this.defineSelectWidget(fieldAf);
                    General.onClickDependentField(fieldAf, {'CDFILDEST': unidadesDest, 'NRORG': getLocalVar('NRORG')});
                } else{
                    fieldAf.dataSourceFilter = [
                        {
                            "name": "NRORG",
                            "value": "",
                            "operator": "="
                        }
                    ];
                    this.defineSelectWidget(fieldAf);
                    General.onClickDependentField(fieldAf, {'NRORG': getLocalVar('NRORG')});
                }
            }
        }
    };

    this.filtraMarcaProduto = function(fieldMarca, produto){
        if(produto){
            fieldMarca.dataSourceFilter = [
                {
                    "name": "CDPRODUTO",
                    "value": "",
                    "operator": "="
                },
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
        }
        General.onClickDependentField(fieldMarca, {'CDPRODUTO': produto, 'NRORG': getLocalVar('NRORG')});
    };

    this.limpaUnidade = function(currentRow){
        currentRow.NMFILIALLANC = '';
        currentRow.NMFILIALDEST = '';
        this.limpaAf(currentRow);
    };

    this.limpaAf = function(currentRow){
        currentRow.AUTOFORNE = '';
    };

    this.limpaMarca = function(fieldMarca, produto){
        fieldMarca.setValue('');
        fieldMarca.readOnly = !produto;
    };

    this.defineSelectWidget = function(field){
        if(field.selectWidget){
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };

    this.abreItemAf = function(widgetProduto, currentRowAf){
        var dataSourceFilter = [];
        dataSourceFilter = [
            {
                "name": "NRAUTOFORN",
                "value": currentRowAf.NRAUTOFORN,
                "operator": "="
            },
            {
                "name": "CDFILDEST",
                "value": currentRowAf.CDFILDEST,
                "operator": "="
            },
            {
                "name": "CDFILLANC",
                "value": currentRowAf.CDFILLANC,
                "operator": "="
            },
            {
                "name": "NRORG",
                "value": currentRowAf.NRORG,
                "operator": "="
            }
        ];

        widgetProduto.dataSourceFilter = dataSourceFilter;
        ScreenService.openSwipe(widgetProduto);
        widgetProduto.activate();
        widgetProduto.reload();
    };

    this.retiraHoraDataProduto = function(widgetProduto) {
        var dataSourceWidgetProd = widgetProduto.dataSource.data;

        for (var posicao in dataSourceWidgetProd) {
            dataSourceWidgetProd[posicao].DTPROGENTAF = dataSourceWidgetProd[posicao].DTPROGENTAF ? dataSourceWidgetProd[posicao].DTPROGENTAF.split(" ")[0] : dataSourceWidgetProd[posicao].DTPROGENTAF;
        }
    };

    this.cancelaEdicaoItemAf = function(widget, fechaSwipe){
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        self.voltaModoListItem(widget, fechaSwipe);
    };

    this.voltaModoListItem = function(widget, fechaSwipe) {
        widget.currentRow.__is_new = false;
        widget.currentRow.changed = false;
        widget.list(fechaSwipe);
        widget.formTemplate = widget.template;
        widget.container.getWidget('produto_af').activate();
    };

    this.excluiItemAf = function(widget){
        var itemAf = widget.dataSource.data;
        var checkItemAf = widget.dataSource.checkedRows;
        var widgetAf = widget.container.getWidget('autorizacao_fornecimento');

        if (itemAf.length == checkItemAf.length) {
            MessageService.showMessageByCode("AF_ITENS_REQUIRED");
        } else {
            var msg = "Confirma exclusão do(s) item(ns) selecionado(s)?";
            ScreenService.confirmMessage(msg, 'INFORMATION', function() {
                widget.removeCheckedRows().then(function(){
                    widget.currentRow.CDFILDEST = widgetAf.currentRow.CDFILDEST;
                    widget.currentRow.CDFILLANC = widgetAf.currentRow.CDFILLANC;
                    widget.currentRow.NRAUTOFORN = widgetAf.currentRow.NRAUTOFORN;
                    widget.currentRow.NRORG = widgetAf.currentRow.NRORG;
                    widget.currentRow.CDEMPRESA = widgetAf.currentRow.CDEMPRESA;
                    widget.currentRow.NRINSJURFORN = widgetAf.currentRow.NRINSJURFORN;
                    widget.currentRow.CDFORNECED = widgetAf.currentRow.CDFORNECED;
                    widget.currentRow.DTAUTOFORN = widgetAf.currentRow.DTAUTOFORN;
                    concluiFechamentoAf(widget.currentRow);
                    atualizaAutoForne(widget.dataSource.data, widgetAf);
                });
            }, function() {
                widget.unSelectAll();
                templateManager.updateTemplate();
            });
        }
    };

    this.salvaItemAf = function(widget){
        blurFields([$("#QTPROGENTAF"), $("#VRPREUNIAF")]);
        if(widget.isValid()) {
            var widgetAf = widget.container.getWidget('autorizacao_fornecimento');
            var currentRowAf = widgetAf.currentRow;
            var currentRowItemAf = widget.currentRow;
            var dadosItemAf = widget.container.getWidget('produto_af');
            var fechaSwipe = false;
            var representacoes = {
                "NRAUTOFORN": currentRowAf.NRAUTOFORN
            };

            if(!currentRowAf.IDBAIXAAF) {
                this.validaNovoItemAf(widget).then(function () {
                    currentRowItemAf.CDEMPRESA = currentRowAf.CDEMPRESA;
                    currentRowItemAf.NRINSJURFORN = currentRowAf.NRINSJURFORN;
                    currentRowItemAf.DTAUTOFORN = currentRowAf.DTAUTOFORN;
                    currentRowItemAf.CDFORNECED = currentRowAf.CDFORNECED;
                    currentRowItemAf.DTULTATU = moment();

                    if (widget.name == 'insere_produto_af') {
                        currentRowItemAf.CDFILDEST = currentRowAf.CDFILDEST;
                        currentRowItemAf.CDFILLANC = currentRowAf.CDFILLANC;
                        currentRowItemAf.NRAUTOFORN = currentRowAf.NRAUTOFORN;
                        currentRowItemAf.DTPROGENTAF = retornaDataProgEntregaAf(dadosItemAf.dataSource.data);
                        currentRowItemAf.IDITAFMIGRADA = 'N';
                        currentRowItemAf.IDBAIXITMFUTURA = 'X';
                        currentRowItemAf.IDDEVOLUCAONFIT = 'N';
                        currentRowItemAf.CDOPERINCLUSAO = getLocalVar('CDOPERADOR');
                        currentRowItemAf.DTINCLUSAO = moment();
                        currentRowItemAf.IDATIVO = 'S';
                        currentRowItemAf.NRORG = getLocalVar('NRORG');
                        fechaSwipe = true;
                    }

                    widget.saveRow().then(function () {
                        concluiFechamentoAf(currentRowItemAf);
                        self.voltaModoListItem(widget, fechaSwipe);

                        if(widget.name == 'insere_produto_af'){
                            dadosItemAf.reload().then(function(){
                                atualizaAutoForne(widget.container.getWidget('produto_af').dataSource.data, widgetAf);
                            });
                        } else{
                            atualizaAutoForne(widget.dataSource.data, widgetAf);
                        }
                    });
                });
            } else {
                MessageService.showMessageByCode("AF_STATUS_BLOCK", { "NRAUTOFORN": currentRowAf.NRAUTOFORN });
            }
        }
    };

    function concluiFechamentoAf(currentRowItemAf){
        AlteracaoAprovacaoAfService.proceVerificaInconsAfs(currentRowItemAf).then(function () {
            AlteracaoAprovacaoAfService.proceImpostoItemAf(currentRowItemAf).then(function () {
                AlteracaoAprovacaoAfService.proceExcluiContaPagarPrevista(currentRowItemAf).then(function() {
                    AlteracaoAprovacaoAfService.proceGeraContaPagarPrevista(currentRowItemAf).then(function(){
                        AlteracaoAprovacaoAfService.proceFechamentoAf(currentRowItemAf).then(function(){
                            MessageService.successNotificationByCode("FECHAMENTO_AF", { "NRAUTOFORN": currentRowItemAf.NRAUTOFORN });
                            AlteracaoAprovacaoAfService.proceConsisteOrcamento(currentRowItemAf);
                        });
                    });
                });
            });
        });
    }

    function retornaDataProgEntregaAf(dadosItemAf){
        var maiorData = '';
        dadosItemAf.forEach(function (linha) {
            var dataProgEnt = moment(linha.DTPROGENTAF, 'DD/MM/YYYY');
            if(maiorData < dataProgEnt){
                maiorData = dataProgEnt;
            }
        });

        return maiorData._i;
    }

    function atualizaAutoForne(dadosItemAf, widgetAF){
        var soma = 0;

        dadosItemAf.forEach(function(itemAf){
            soma += _toFloat(itemAf.PRECOTOTAL);
        });

        widgetAF.getField('VRTOTALAF').setValue(soma.toString().replace('.', ','));
    }

    this.validaNovoItemAf = function(widget){
        var deferred = ZHPromise.defer();

        var currentRowItemAf = widget.currentRow;
        var currentRowAf = widget.container.getWidget('autorizacao_fornecimento').currentRow;
        var dadosItemAf = widget.container.getWidget('produto_af').dataSource.data;

        if(verificaValorNegativo(currentRowItemAf) && verificaValorTotalReal(dadosItemAf, currentRowAf, widget)) {
            if (widget.name == 'insere_produto_af') {

                var promises = [];

                var nrorg = currentRowAf.NRORG;
                var nrAutoForn = currentRowAf.NRAUTOFORN;
                var cdFornecedor = currentRowAf.CDFORNECED;
                var cdProduto = currentRowItemAf.CDPRODUTO;
                var nmProduto = currentRowItemAf.NMPRODUTO;
                var dtAutoForn = currentRowAf.DTAUTOFORN;
                var cdFilDest = currentRowAf.CDFILDEST;
                var cdFilLanc = currentRowAf.CDFILLANC;
                var cdMarca = currentRowItemAf.CDMARCA;
                var nmMarca = currentRowItemAf.NMMARCA;
                var tpFormPagamento = currentRowAf.IDTPFORPGTAF;

                promises.push(AlteracaoAprovacaoAfService.verificaProdutoFornecedor(nrorg, cdFornecedor, cdProduto));
                promises.push(AlteracaoAprovacaoAfService.verificaQualificacaoMarca(nrorg, cdProduto, cdMarca, cdFilDest, dtAutoForn));
                promises.push(AlteracaoAprovacaoAfService.verificaProdQualificadoForn(nrorg, cdProduto, cdFornecedor, cdFilDest, dtAutoForn));
                promises.push(AlteracaoAprovacaoAfService.verificaProdutoInativo(nrorg, cdProduto, cdFilDest));

                if (tpFormPagamento == 'V') {
                    promises.push(AlteracaoAprovacaoAfService.verificaPrazoPagamento(nrorg, cdFilDest,cdFilLanc, nrAutoForn));
                }

                ZHPromise.all(promises).then(function (callback) {
                    var itemAfRepetido = verificaExiteItemAf(dadosItemAf, currentRowItemAf);
                    var produtoFornecedor = verificaProdutoFornecedor(callback[0], nmProduto);
                    var qualificacaoMarca = verificaQualificacaoMarca(callback[1], nmProduto, nmMarca);
                    var prodQualificadoForn = verificaProdQualificadoForn(callback[2], nmProduto);
                    var produtoInativo  = verificaProdutoInativo(callback[3], nmProduto);
                    var formaPagamento = verificaFormaPagamento(callback[4], nrAutoForn);

                    if(!itemAfRepetido || !produtoFornecedor || !qualificacaoMarca || !prodQualificadoForn || !produtoInativo ||!formaPagamento){
                        deferred.reject();
                    } else {
                        deferred.resolve();
                    }
                });
            } else {
                deferred.resolve();
            }
        } else{
            deferred.reject();
        }

        return deferred;
    };

    function verificaValorTotalReal(dadosItemAf, currentRowAf, widget){
        if (acrescimo) {
            toFloatArray(currentRowAf, ['VRTOTALAF', 'VRTOTALAFORG']);
            var somaItemAf = 0;
            var valorTotalAntigo = currentRowAf.VRTOTALAF;
            var valorTotalReal = currentRowAf.VRTOTALAFORG;
            var representacoes = {
                "valorTotalReal": valorTotalReal.toFixed(2).toString().replace('.', ',')
            };

            if (!valorTotalReal) {
                valorTotalReal = valorTotalAntigo + valorTotalAntigo * acrescimo / 100;
                currentRowAf.VRTOTALAFORG = valorTotalReal;
                AlteracaoAprovacaoAfService.salvaValorTotalReal(currentRowAf);
            } 

            dadosItemAf.forEach(function (linha) {
                somaItemAf += _toFloat(linha.PRECOTOTAL);
            });

            if(widget.name == 'insere_produto_af'){
                somaItemAf += _toFloat(widget.getField('PRECOTOTAL').value());
            }

            if (somaItemAf > valorTotalReal) {
                MessageService.showMessageByCode("VLR_TOTAL_AF_SUPERIOR", { "VALORTOTALREAL": valorTotalReal.toFixed(2).toString().replace('.', ',') });
                return false;
            } else {
                return true;
            }
        } else {
            MessageService.showMessageByCode("PARAM_VLR_ACRS_AF_REQUIRED");
            return false;
        }
    }

    function verificaValorNegativo(currentRow) {
        toFloatArray(currentRow, ['QTPROGENTAF', 'VRPREUNIAF']);
        if (currentRow.QTPROGENTAF <= 0) {
            MessageService.showMessageByCode("QTD_MAIOR_ZERO");
            return false;
        }
        if (currentRow.VRPREUNIAF <= 0) {
            MessageService.showMessageByCode("PRECO_UNIT_MAIOR_ZERO");
            return false;
        }
        return true;
    }

    function verificaProdutoFornecedor(produtoFornecedor, nmProduto){
        var fornecedor = produtoFornecedor.dataset.fornecedor[0].FORNECEDOR;

        if(fornecedor == '0') {
            MessageService.showMessageByCode("PRODUTO_NAO_VINCULADO", { "NMPRODUTO": nmProduto });
            return false;
        } else {
            return true;
        }
    }

    function verificaQualificacaoMarca(qualificacaoMarca, nmProduto, nmMarca) {
        var marca = qualificacaoMarca.dataset.qualificacao.length;
        if(marca) {
            MessageService.showMessageByCode("MARCA_QUALIFICACAO_VENCIDA", { "NMMARCA": nmMarca, "NMPRODUTO": nmProduto });
            return false;
        } else {
            return true;
        }
    }

    function verificaProdQualificadoForn(prodQualificadoForn, nmProduto) {

        var prodForn = prodQualificadoForn.dataset.prodForn.length;
        if(prodForn) {
            MessageService.showMessageByCode("PRODUTO_NAO_QUALIFICADO", { "NMPRODUTO": nmProduto });
            return false;
        } else {
            return true;
        }
    }

    function verificaExiteItemAf(dadosItemAf, currentRowItemAf) {
        for(var i = 0; i < dadosItemAf.length; i ++) {
            if(dadosItemAf[i].CDMARCA == currentRowItemAf.CDMARCA && dadosItemAf[i].CDPRODUTO == currentRowItemAf.CDPRODUTO) {
                MessageService.showMessageByCode("AF_JA_EXISTENTE", { "NMPRODUTO": currentRowItemAf.NMPRODUTO, "NMMARCA": currentRowItemAf.NMMARCA });
                return false;
            }
        }
        return true;
    }

    function verificaProdutoInativo(produtoInativo, nmProduto) {
        var prodInativo = produtoInativo.dataset.produto.length;
        if(prodInativo) {
            MessageService.showMessageByCode("PRODUTO_IVATIVO", { "NMPRODUTO": nmProduto });
            return false;
        } else{
            return true;
        }
    }

    function verificaFormaPagamento(formaPagamento, nrAutoForn) {
        if(formaPagamento) {
            if (formaPagamento.dataset.prazopgtaf.length === 0) {
                MessageService.showMessageByCode("AF_SEM_PRAZO_PAGTO", { "NRAUTOFORN": nrAutoForn });
                return false;
            }
        }
        return true;
    }

    this.atualizaTotalProd = function(row) {
        var quantidade = _toFloat(row.QTPROGENTAF);
        var preco = _toFloat(row.VRPREUNIAF);
        row.PRECOTOTAL = quantidade * preco;
    };

    var toFloatArray = function (row, fields) {
        fields.forEach(function(field){
            row[field] = _toFloat(row[field]);
        });
    };

    var _toFloat = function(val) {
        var _float = (typeof val === "number") && !isNaN(val) ? val : parseFloat(val.replace(/\./g, '').replace(',', '.')); 
        return _float;
    }; 

    var blurFields = function(fields) {
        fields.forEach(function(field){
            field.blur();
        });
    }; 
}

Configuration(function (ContextRegister) {
    ContextRegister.register('AlteracaoAprovacaoAfController', AlteracaoAprovacaoAfController);
});